import util
import uiutil
import localization
CONTACTSGROUP = (1, 0)
TRADEGROUP = (2, 0)
CONTAINERGROUPS = (3, 0)
CHANGESGROUP = (4, 0)
DESTRUCTIVEGROUP = (5, 0)
SELECTIONGROUP = (6, 0)
SHOWINFOGROUP = (7, 0)
GMWMEXTRAS = (8, 0)
SUBGROUP1 = (9, 0)
ACTIONSGROUP = (11, 0)
CORPGROUP = (12, 0)
RAGEQUITGROUP = (13, 0)
FLEETGROUP = (14, 0)
CONFIGGROUP = (16, 0)
NAVIGATIONGROUP2 = (15, 0)
SHIPSPECIALGROUP = (17, 0)
CONTACTSGROUP2 = (18, 0)
ACTIONSGROUP2 = (19, 0)
BLUEPRINTGROUP = (20, 0)

def PrepareKey(path):
    string = localization.GetByLabel(path)
    string = string.lower()
    key = uiutil.StripTags(string, stripOnly=['localized'])
    return key


menuGroupsFromCaption = {PrepareKey('UI/PeopleAndPlaces/AddAllianceContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/AddContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/AddCorpContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/AddToAddressbook'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/BlockContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/Blocked'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/RemoveCorpContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/RemoveAllianceContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/RemoveFromAddressbook'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/RemoveContact'): CONTACTSGROUP,
 PrepareKey('UI/Mail/LabelRemove'): CONTACTSGROUP,
 PrepareKey('UI/Mail/AssignLabel'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/EditAllianceContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/EditContact'): CONTACTSGROUP,
 PrepareKey('UI/PeopleAndPlaces/EditCorpContact'): CONTACTSGROUP,
 PrepareKey('UI/Fleet/FormFleetWith'): CONTACTSGROUP2,
 PrepareKey('UI/Commands/CapturePortrait'): CONTACTSGROUP2,
 PrepareKey('UI/Chat/StartConversation'): CONTACTSGROUP2,
 PrepareKey('UI/Chat/InviteToChat'): CONTACTSGROUP2,
 PrepareKey('UI/EVEMail/SendPilotEVEMail'): CONTACTSGROUP2,
 PrepareKey('UI/Inventory/ItemActions/BuyThisType'): TRADEGROUP,
 PrepareKey('UI/Contracts/ContractEntry/IgnoreFromThisIssuer'): TRADEGROUP,
 PrepareKey('UI/Inventory/ItemActions/SellThisItem'): TRADEGROUP,
 PrepareKey('UI/Market/TradeWithCharacter'): TRADEGROUP,
 PrepareKey('UI/Wallet/WalletWindow/MenuTransferFromCorp'): TRADEGROUP,
 PrepareKey('UI/Wallet/WalletWindow/MenuTransferToCorp'): TRADEGROUP,
 PrepareKey('UI/Inflight/POS/TransferSovStructureOwnership'): TRADEGROUP,
 PrepareKey('UI/Inventory/ItemActions/ViewTypesMarketDetails'): TRADEGROUP,
 PrepareKey('UI/Inventory/ItemActions/FindInContracts'): TRADEGROUP,
 PrepareKey('UI/Corporations/Common/ViewCorpMemberDetails'): TRADEGROUP,
 PrepareKey('UI/Wallet/WalletWindow/MenuViewTransactions'): TRADEGROUP,
 PrepareKey('UI/Inventory/ItemActions/AddTypeToMarketQuickbar'): TRADEGROUP,
 PrepareKey('UI/Inventory/ItemActions/RemoveTypeFromMarketQuickbar'): TRADEGROUP,
 PrepareKey('UI/Inventory/ItemActions/CreateContract'): TRADEGROUP,
 PrepareKey('UI/Commands/GiveMoney'): TRADEGROUP,
 PrepareKey('UI/Inflight/POS/AccessPOSActiveCrystal'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSAmmo'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSCrystalStorage'): CONTAINERGROUPS,
 PrepareKey('UI/PI/Common/AccessCustomOffice'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSFuelBay'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSRefinery'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSResources'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSStorage'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSStrontiumBay'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/AccessPOSVessels'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenAmmoHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenCargo'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenCargoHold'): CONTAINERGROUPS,
 PrepareKey('UI/Inventory/ItemActions/OpenContainer'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenCorpHangars'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenDescription'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenDroneBay'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenFuelBay'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenGasHold'): CONTAINERGROUPS,
 PrepareKey('UI/PI/Common/AccessCustomOffice'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenIndustrialShipHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenLargeShipHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenMediumShipHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenMineralHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenMyCargo'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenOreHold'): CONTAINERGROUPS,
 PrepareKey('UI/PI/Common/OpenPlanetaryCommoditiesHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenSalvageHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenShipHold'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenShipMaintenanceBay'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenSmallShipHold'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/StoreVesselInSMA'): CONTAINERGROUPS,
 PrepareKey('UI/Inventory/ItemActions/ViewContents'): CONTAINERGROUPS,
 PrepareKey('UI/Commands/OpenCommandCenterHold'): CONTAINERGROUPS,
 PrepareKey('UI/Inflight/POS/CancelAnchoring'): CHANGESGROUP,
 PrepareKey('UI/Corporations/CorporationWindow/Wars/CancelMutualMenuOption'): CHANGESGROUP,
 PrepareKey('UI/Market/Orders/CancelOrder'): CHANGESGROUP,
 PrepareKey('UI/Neocom/Petition/CancelPetition'): CHANGESGROUP,
 PrepareKey('UI/Inflight/menuCancelRepair'): CHANGESGROUP,
 PrepareKey('UI/Inflight/MoonMining/Processes/ChangeHarvestedMaterial'): CHANGESGROUP,
 PrepareKey('/Carbon/UI/Controls/ScrollEntries/ChangeLabel'): CHANGESGROUP,
 PrepareKey('UI/Commands/ChangeName'): CHANGESGROUP,
 PrepareKey('UI/Inflight/MoonMining/Processes/ChangeSiloType'): CHANGESGROUP,
 PrepareKey('UI/Corporations/CorporationWindow/Wars/DeclareMutualMenuOption'): CHANGESGROUP,
 PrepareKey('UI/Drones/DelegateDroneControl'): CHANGESGROUP,
 PrepareKey('UI/Fleet/FleetWindow/EditAdvert'): CHANGESGROUP,
 PrepareKey('UI/Inflight/Scanner/EditCurrentFilter'): CHANGESGROUP,
 PrepareKey('UI/Neocom/Petition/Escalate'): CHANGESGROUP,
 PrepareKey('UI/Chat/ChannelWindow/ForgetChannel'): CHANGESGROUP,
 PrepareKey('UI/Chat/ChannelWindow/ForgetList'): CHANGESGROUP,
 PrepareKey('UI/Inflight/Scanner/IgnoreOtherResults'): CHANGESGROUP,
 PrepareKey('UI/Inflight/Scanner/IngoreResult'): CHANGESGROUP,
 PrepareKey('UI/Chat/LeaveAudio'): CHANGESGROUP,
 PrepareKey('UI/Chat/ChannelWindow/LeaveChannel'): CHANGESGROUP,
 PrepareKey('UI/Fleet/LeaveMyFleet'): CHANGESGROUP,
 PrepareKey('UI/Mail/LeaveMailingList'): CHANGESGROUP,
 PrepareKey('UI/Fleet/Watchlist/LeavePrivateVoiceChannel'): CHANGESGROUP,
 PrepareKey('UI/Inventory/ItemActions/LeaveShip'): CHANGESGROUP,
 PrepareKey('UI/Commands/MoveDrone'): CHANGESGROUP,
 PrepareKey('UI/Drones/MoveToDroneBay'): CHANGESGROUP,
 PrepareKey('UI/SkillQueue/AddSkillMenu/AbortTraining'): CHANGESGROUP,
 PrepareKey('UI/PeopleAndPlaces/LabelsRename'): CHANGESGROUP,
 PrepareKey('UI/Notepad/RenameNote'): CHANGESGROUP,
 PrepareKey('UI/Corporations/CorporationWindow/Wars/RetractMenuOption'): CHANGESGROUP,
 PrepareKey('UI/Drones/ReturnDroneAndOrbit'): CHANGESGROUP,
 PrepareKey('UI/Drones/ReturnDroneControl'): CHANGESGROUP,
 PrepareKey('UI/Drones/ReturnDroneToBay'): CHANGESGROUP,
 PrepareKey('UI/Drones/LaunchDrones'): CHANGESGROUP,
 PrepareKey('UI/Inflight/ScoopToCargoHold'): CHANGESGROUP,
 PrepareKey('UI/Drones/ScoopDroneToBay'): CHANGESGROUP,
 PrepareKey('UI/Inflight/POS/ScoopToShipMaintenanceBay'): CHANGESGROUP,
 PrepareKey('UI/Neocom/Petition/ClosePetition'): CHANGESGROUP,
 PrepareKey('UI/Neocom/Petition/Delete'): CHANGESGROUP,
 PrepareKey('UI/PeopleAndPlaces/UnblockContact'): CHANGESGROUP,
 PrepareKey('UI/Inflight/RemoveBookmark'): CHANGESGROUP,
 PrepareKey('UI/Inflight/AbandonAllCargo'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inflight/AbandonAllWrecks'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inflight/AbandonCargo'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Drones/AbandonDrone'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inflight/AbandonWreack'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Accessories/Calculator/Clear'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inflight/Scanner/ClearAllIgnoredResults'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Map/Navigation/menuClearWaypoints'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Fitting/ClearGroup'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inflight/Scanner/ClearIgnoredResult'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inflight/Scanner/ClearResult'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Map/Navigation/menuClearRoute'): DESTRUCTIVEGROUP,
 PrepareKey('/Carbon/UI/Common/Close'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Mail/EmptyTrash'): DESTRUCTIVEGROUP,
 PrepareKey('UI/CharacterSelection/RemoveFromBiomass'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Generic/RemoveItem'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Notepad/RemoveNote'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Agents/Commands/RemoveOffer'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/Repackage'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Chat/ReportIskSpammer'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/Reprocess'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Corporations/Assets/TrashItemsAtLocation'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Chat/ChannelWindow/UnsubscribeFromList'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/Jettison'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Fleet/Ranks/Boss'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inflight/JumpToFleetMember'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/LaunchShip'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/LaunchShipFromBay'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/LaunchForCorp'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/LaunchForSelf'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Commands/UndockFromStation'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Inventory/ItemActions/StripFitting'): DESTRUCTIVEGROUP,
 PrepareKey('UI/InfoWindow/ReportBot'): DESTRUCTIVEGROUP,
 PrepareKey('UI/Corporations/CorpApplications/WithdrawApplication'): DESTRUCTIVEGROUP,
 PrepareKey('UI/CharacterSheet/CharacterSheetWindow/JumpCloneScroll/Destroy'): DESTRUCTIVEGROUP,
 PrepareKey('UI/CharacterSelection/CompleteTermination'): RAGEQUITGROUP,
 PrepareKey('UI/Fleet/MakeFleetLeader'): RAGEQUITGROUP,
 PrepareKey('UI/PeopleAndPlaces/DeleteNotification'): RAGEQUITGROUP,
 PrepareKey('UI/Notepad/DeleteNote'): RAGEQUITGROUP,
 PrepareKey('UI/Chat/ChannelWindow/DeleteChannel'): RAGEQUITGROUP,
 PrepareKey('UI/Mail/Delete'): RAGEQUITGROUP,
 PrepareKey('/Carbon/UI/Controls/ScrollEntries/DeleteFolder'): RAGEQUITGROUP,
 PrepareKey('UI/Commands/DeleteGroup'): RAGEQUITGROUP,
 PrepareKey('UI/Chat/ChannelWindow/DeleteList'): RAGEQUITGROUP,
 PrepareKey('UI/Mail/DeleteMailingList'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/Scanner/DeleteCurrentFilter'): RAGEQUITGROUP,
 PrepareKey('UI/Mail/Notifications/DeleteAll'): RAGEQUITGROUP,
 PrepareKey('UI/Common/Delete'): RAGEQUITGROUP,
 PrepareKey('UI/Contracts/ContractEntry/Delete'): RAGEQUITGROUP,
 PrepareKey('UI/Contracts/ContractEntry/Dismiss'): RAGEQUITGROUP,
 PrepareKey('UI/Corporations/Common/ExpelCorpMember'): RAGEQUITGROUP,
 PrepareKey('UI/Fleet/KickFleetMember'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/PutStructureOffline'): RAGEQUITGROUP,
 PrepareKey('UI/Corporations/Common/QuitCorp'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/POS/RelinquishPOSControl'): RAGEQUITGROUP,
 PrepareKey('UI/Commands/Remove'): RAGEQUITGROUP,
 PrepareKey('UI/Fleet/FleetWindow/RemoveAdvert'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/MoonMining/Processes/RemoveConnection'): RAGEQUITGROUP,
 PrepareKey('UI/Inventory/ItemActions/RemoveTypeFromMarketQuickbar'): RAGEQUITGROUP,
 PrepareKey('UI/Fleet/RemovePilotFromWatchlist'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/RemoveWaypoint'): RAGEQUITGROUP,
 PrepareKey('UI/Inventory/ItemActions/Refine'): RAGEQUITGROUP,
 PrepareKey('UI/Corporations/Common/ResignAsCEO'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/SelfDestructShipOrPod'): RAGEQUITGROUP,
 PrepareKey('UI/CharacterSelection/Terminate'): RAGEQUITGROUP,
 PrepareKey('UI/Inventory/ItemActions/ToHangarAndRefine'): RAGEQUITGROUP,
 PrepareKey('UI/Mail/Trash'): RAGEQUITGROUP,
 PrepareKey('UI/Mail/TrashAll'): RAGEQUITGROUP,
 PrepareKey('UI/Inventory/ItemActions/TrashIt'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/UnanchorObject'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/POS/UnanchorStructure'): RAGEQUITGROUP,
 PrepareKey('UI/Control/Entries/ImplantUnplug'): RAGEQUITGROUP,
 PrepareKey('UI/Inflight/EjectFromShip'): RAGEQUITGROUP,
 PrepareKey('UI/Contracts/BreakContract'): RAGEQUITGROUP,
 'Remove from Selection': RAGEQUITGROUP,
 PrepareKey('UI/Common/Copy'): SELECTIONGROUP,
 PrepareKey('UI/Common/CopyAll'): SELECTIONGROUP,
 PrepareKey('UI/Browser/CopyImageLocation'): SELECTIONGROUP,
 PrepareKey('UI/Browser/CopyLinkLocation'): SELECTIONGROUP,
 PrepareKey('/Carbon/UI/Controls/Common/CopySelected'): SELECTIONGROUP,
 PrepareKey('/Carbon/UI/Commands/CopyURL'): SELECTIONGROUP,
 PrepareKey('UI/Common/Cut'): SELECTIONGROUP,
 PrepareKey('/Carbon/UI/Controls/Common/CutSelected'): SELECTIONGROUP,
 PrepareKey('/Carbon/UI/Controls/Common/Paste'): SELECTIONGROUP,
 PrepareKey('UI/Common/SelectAll'): SELECTIONGROUP,
 PrepareKey('UI/Inventory/StackAll'): SELECTIONGROUP,
 PrepareKey('UI/Common/SortBy'): SELECTIONGROUP,
 PrepareKey('UI/Inventory/InvertSelection'): SELECTIONGROUP,
 PrepareKey('UI/Chat/ToggleTimestamp'): SELECTIONGROUP,
 'gm / wm extras': GMWMEXTRAS,
 'refresh': GMWMEXTRAS,
 'inactive': GMWMEXTRAS,
 PrepareKey('UI/Commands/ShowInfo'): SHOWINFOGROUP,
 PrepareKey('UI/Common/Character'): SUBGROUP1,
 PrepareKey('UI/Common/Planets'): SUBGROUP1,
 PrepareKey('UI/Common/LocationTypes/Stargates'): SUBGROUP1,
 PrepareKey('UI/Common/LocationTypes/Stations'): SUBGROUP1,
 PrepareKey('UI/Common/LocationTypes/AsteroidBelts'): SUBGROUP1,
 PrepareKey('UI/Common/Pilot'): SUBGROUP1,
 PrepareKey('UI/Fleet/Fleet'): SUBGROUP1,
 PrepareKey('UI/Common/Location'): SUBGROUP1,
 PrepareKey('UI/Inflight/OrbitObject'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/Submenus/WarpToWithin'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/Submenus/KeepAtRange'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/ApproachObject'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/LookAtObject'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/ActivateAutopilot'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/DeactivateAutopilot'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/StopMyShip'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/AlignTo'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/ResetCamera'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/BoardShip'): ACTIONSGROUP,
 PrepareKey('UI/Fleet/WarpToMember'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/Jump'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/DockInStation'): ACTIONSGROUP,
 PrepareKey('UI/Fleet/WarpToMemberSubmenuOption'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/ModuleRacks/ReloadAll'): ACTIONSGROUP,
 PrepareKey('UI/Drones/EngageTarget'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/LockTarget'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/UnlockTarget'): ACTIONSGROUP,
 PrepareKey('UI/Market/Marketbase/BuyThis'): ACTIONSGROUP,
 PrepareKey('UI/Market/Orders/ModifyOrder'): ACTIONSGROUP,
 PrepareKey('UI/Inflight/ActivateGate'): ACTIONSGROUP,
 PrepareKey('UI/Contracts/ContractEntry/ViewContract'): ACTIONSGROUP,
 PrepareKey('UI/Inventory/ItemActions/FitToActiveShip'): ACTIONSGROUP2,
 PrepareKey('UI/Inflight/PutStructureOnline'): ACTIONSGROUP2,
 PrepareKey('UI/Inflight/POS/AssumeStructureControl'): ACTIONSGROUP2,
 PrepareKey('UI/Inventory/ItemActions/AssembleShip'): ACTIONSGROUP2,
 PrepareKey('UI/Inventory/ItemActions/AssembleContainer'): ACTIONSGROUP2,
 PrepareKey('UI/Inventory/ItemActions/MakeShipActive'): ACTIONSGROUP2,
 PrepareKey('UI/Commands/EnterHangar'): ACTIONSGROUP2,
 PrepareKey('UI/Neocom/CqBtn'): ACTIONSGROUP2,
 PrepareKey('UI/Inventory/ItemActions/GetRepairQuote'): ACTIONSGROUP2,
 PrepareKey('UI/PI/Common/ViewInPlanetMode'): NAVIGATIONGROUP2,
 PrepareKey('UI/Inflight/AddWaypoint'): NAVIGATIONGROUP2,
 PrepareKey('UI/Inflight/AddFirstWaypoint'): NAVIGATIONGROUP2,
 PrepareKey('UI/Inflight/BookmarkLocation'): NAVIGATIONGROUP2,
 PrepareKey('UI/Inflight/ApproachLocation'): NAVIGATIONGROUP2,
 PrepareKey('UI/PeopleAndPlaces/EditViewLocation'): NAVIGATIONGROUP2,
 PrepareKey('UI/Inflight/ShowSystemInMapBrowser'): NAVIGATIONGROUP2,
 PrepareKey('UI/Commands/ShowLocationOnMap'): NAVIGATIONGROUP2,
 PrepareKey('UI/Inflight/SetDestination'): NAVIGATIONGROUP2,
 PrepareKey('UI/Corporations/Common/EditCorpMember'): CORPGROUP,
 PrepareKey('UI/Corporations/Common/TransferCorpCash'): CORPGROUP,
 PrepareKey('UI/Corporations/Common/AwardCorpMemberDecoration'): CORPGROUP,
 PrepareKey('UI/Commands/SetName'): CONFIGGROUP,
 PrepareKey('UI/Inflight/ConfigureShip'): CONFIGGROUP,
 PrepareKey('UI/Inflight/Submenus/BridgeTo'): CONFIGGROUP,
 PrepareKey('UI/Fleet/BridgeToMember'): CONFIGGROUP,
 PrepareKey('UI/Inventory/ItemActions/SetNewPasswordForContainer'): CONFIGGROUP,
 PrepareKey('UI/Inflight/POS/SetNewPasswordForForceField'): CONFIGGROUP,
 PrepareKey('UI/Inventory/ItemActions/SetNewConfigPasswordForContainer'): CONFIGGROUP,
 PrepareKey('UI/Inventory/ItemActions/ConfigureALSContainer'): CONFIGGROUP,
 PrepareKey('UI/Commands/RetrievePassword'): CONFIGGROUP,
 PrepareKey('UI/Inflight/POS/ManageControlTower'): CONFIGGROUP,
 PrepareKey('UI/Fitting/UseFittingService'): SHIPSPECIALGROUP,
 PrepareKey('UI/Inflight/Submenus/JumpTo'): SHIPSPECIALGROUP,
 PrepareKey('UI/Inflight/POS/EnterStarbasePassword'): SHIPSPECIALGROUP,
 PrepareKey('UI/Fleet/WarpFleet'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpFleetToLocation'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpFleetToMember'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpSquad'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpSquadToLocation'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpSquadToMember'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpWing'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpWingToLocation'): FLEETGROUP,
 PrepareKey('UI/Fleet/WarpWingToMember'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpWingToMember'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpWingToWithin'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpSquadToMember'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpSquadToWithin'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpSquadToLocationWithin'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpFleetToMember'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpFleetToWithin'): FLEETGROUP,
 PrepareKey('UI/Fleet/FleetSubmenus/WarpFleetToLocationWithin'): FLEETGROUP}
menuHierarchy = [GMWMEXTRAS,
 ACTIONSGROUP,
 SHOWINFOGROUP,
 ACTIONSGROUP2,
 FLEETGROUP,
 SHIPSPECIALGROUP,
 NAVIGATIONGROUP2,
 SUBGROUP1,
 CONFIGGROUP,
 CONTAINERGROUPS,
 TRADEGROUP,
 CHANGESGROUP,
 CONTACTSGROUP,
 CONTACTSGROUP2,
 None,
 BLUEPRINTGROUP,
 CORPGROUP,
 DESTRUCTIVEGROUP,
 RAGEQUITGROUP,
 SELECTIONGROUP]

def GetMenuGroup(caption, *args):
    unlocalizedCaption = None
    if isinstance(caption, tuple):
        return caption[1]
    unlocalizedCaption = uiutil.StripTags(caption, stripOnly=['localized'])
    unlocalizedCaption = unlocalizedCaption.lower()
    group = menuGroupsFromCaption.get(unlocalizedCaption, None)
    return group


exports = util.AutoExports('menu', locals())

